function H = bandfilter(type, band, M, N, D0, W, n)
%BANDFILTR Computes frequency domain band filters.
%  BAND 'reject'  'pass'    

[U, V] = dftuv(M, N);
D = hypot(U, V);

if nargin < 7
    n = 1; 
end

switch lower(type)
    case 'ideal'
        RI = D <= D0 - (W/2);
        R0 = D >= D0 + (W/2);
        HR = R0 | RI;
    case 'btw'
        HR = 1./(1 + (((D*W)./(D.^2 - D0^2)).^2*n));
    case 'gaussian'
        HR = 1 - exp(-((D.^2 - D0^2)./(D.*W + eps)).^2);
    otherwise
        error('nespravny typ.')
end

switch lower(band)
   case 'pass' 
        H = 1 - HR;
    case 'reject'
        H = HR;
    otherwise
        error('nespravny typ.')
end
end